/*
 * This file is generated by jOOQ.
 */
package de.ship.clip.db.tables;


import de.ship.clip.db.Config;
import de.ship.clip.db.Keys;
import de.ship.clip.db.enums.EnumLocale;
import de.ship.clip.db.tables.records.TTranslationRecord;

import java.util.Arrays;
import java.util.List;
import java.util.function.Function;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Function4;
import org.jooq.Identity;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Records;
import org.jooq.Row4;
import org.jooq.Schema;
import org.jooq.SelectField;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TTranslation extends TableImpl<TTranslationRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>config.t_translation</code>
     */
    public static final TTranslation T_TRANSLATION = new TTranslation();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TTranslationRecord> getRecordType() {
        return TTranslationRecord.class;
    }

    /**
     * The column <code>config.t_translation.pk</code>.
     */
    public final TableField<TTranslationRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>config.t_translation.langkey</code>.
     */
    public final TableField<TTranslationRecord, String> LANGKEY = createField(DSL.name("langkey"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>config.t_translation.localecode</code>.
     */
    public final TableField<TTranslationRecord, EnumLocale> LOCALECODE = createField(DSL.name("localecode"), SQLDataType.VARCHAR.nullable(false).asEnumDataType(de.ship.clip.db.enums.EnumLocale.class), this, "");

    /**
     * The column <code>config.t_translation.value</code>.
     */
    public final TableField<TTranslationRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB.nullable(false), this, "");

    private TTranslation(Name alias, Table<TTranslationRecord> aliased) {
        this(alias, aliased, null);
    }

    private TTranslation(Name alias, Table<TTranslationRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>config.t_translation</code> table reference
     */
    public TTranslation(String alias) {
        this(DSL.name(alias), T_TRANSLATION);
    }

    /**
     * Create an aliased <code>config.t_translation</code> table reference
     */
    public TTranslation(Name alias) {
        this(alias, T_TRANSLATION);
    }

    /**
     * Create a <code>config.t_translation</code> table reference
     */
    public TTranslation() {
        this(DSL.name("t_translation"), null);
    }

    public <O extends Record> TTranslation(Table<O> child, ForeignKey<O, TTranslationRecord> key) {
        super(child, key, T_TRANSLATION);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Config.CONFIG;
    }

    @Override
    public Identity<TTranslationRecord, Integer> getIdentity() {
        return (Identity<TTranslationRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TTranslationRecord> getPrimaryKey() {
        return Keys.T_TRANSLATION_PKEY;
    }

    @Override
    public List<UniqueKey<TTranslationRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.T_TRANSLATION_LANGKEY_LOCALECODE_KEY);
    }

    @Override
    public TTranslation as(String alias) {
        return new TTranslation(DSL.name(alias), this);
    }

    @Override
    public TTranslation as(Name alias) {
        return new TTranslation(alias, this);
    }

    @Override
    public TTranslation as(Table<?> alias) {
        return new TTranslation(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TTranslation rename(String name) {
        return new TTranslation(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TTranslation rename(Name name) {
        return new TTranslation(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TTranslation rename(Table<?> name) {
        return new TTranslation(name.getQualifiedName(), null);
    }

    // -------------------------------------------------------------------------
    // Row4 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row4<Integer, String, EnumLocale, String> fieldsRow() {
        return (Row4) super.fieldsRow();
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Function)}.
     */
    public <U> SelectField<U> mapping(Function4<? super Integer, ? super String, ? super EnumLocale, ? super String, ? extends U> from) {
        return convertFrom(Records.mapping(from));
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Class,
     * Function)}.
     */
    public <U> SelectField<U> mapping(Class<U> toType, Function4<? super Integer, ? super String, ? super EnumLocale, ? super String, ? extends U> from) {
        return convertFrom(toType, Records.mapping(from));
    }
}
